diff --git a/drivers/crypto/ccp/ccp_pmd_ops.c b/drivers/crypto/ccp/ccp_pmd_ops.c
index d5041f0ec..768378033 100644
--- a/drivers/crypto/ccp/ccp_pmd_ops.c
+++ b/drivers/crypto/ccp/ccp_pmd_ops.c
@@ -47,7 +47,7 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 20,                     \
+					 .min = 1,                      \
 					 .max = 20,                     \
 					 .increment = 0                 \
 				 },                                     \
@@ -68,9 +68,9 @@
 					 .increment = 0                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 28,                     \
+					 .min = 1,                      \
 					 .max = 28,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }                                           \
@@ -89,9 +89,9 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 28,                     \
+					 .min = 1,                      \
 					 .max = 28,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }                                           \
@@ -110,9 +110,9 @@
 					 .increment = 0                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 28,                     \
+					 .min = 1,                      \
 					 .max = 28,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }                                           \
@@ -131,9 +131,9 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 28,                     \
+					 .min = 1,                      \
 					 .max = 28,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }                                           \
@@ -173,9 +173,9 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 32,                     \
+					 .min = 1,                      \
 					 .max = 32,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }                                           \
@@ -215,9 +215,9 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 32,                     \
+					 .min = 1,                      \
 					 .max = 32,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }						\
@@ -257,9 +257,9 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 48,                     \
+					 .min = 1,                      \
 					 .max = 48,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }                                           \
@@ -299,9 +299,9 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 48,                     \
+					 .min = 1,                      \
 					 .max = 48,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }                                           \
@@ -341,9 +341,9 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 64,                     \
+					 .min = 1,                      \
 					 .max = 64,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			 }, }                                           \
@@ -383,9 +383,9 @@
 					 .increment = 1                 \
 				 },                                     \
 				 .digest_size = {                       \
-					 .min = 64,                     \
+					 .min = 1,                      \
 					 .max = 64,                     \
-					 .increment = 0                 \
+					 .increment = 1                 \
 				 },                                     \
 				 .aad_size = { 0 }                      \
 			}, }                                            \
@@ -536,7 +536,7 @@
 					 .increment = 1			\
 				 },					\
 				 .digest_size = {			\
-					 .min = 16,			\
+					 .min = 1,			\
 					 .max = 16,			\
 					 .increment = 0			\
 				 },					\