diff --git a/drivers/compress/zlib/zlib_pmd_private.h b/drivers/compress/zlib/zlib_pmd_private.h
index 2c6e83d45c88..bda49759dc1f 100644
--- a/drivers/compress/zlib/zlib_pmd_private.h
+++ b/drivers/compress/zlib/zlib_pmd_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2018 Cavium Networks
  */
 
-#ifndef _RTE_ZLIB_PMD_PRIVATE_H_
-#define _RTE_ZLIB_PMD_PRIVATE_H_
+#ifndef _ZLIB_PMD_PRIVATE_H_
+#define _ZLIB_PMD_PRIVATE_H_
 
 #include <zlib.h>
 #include <rte_compressdev.h>
@@ -68,4 +68,4 @@ zlib_set_stream_parameters(const struct rte_comp_xform *xform,
 /** Device specific operations function pointer structure */
 extern struct rte_compressdev_ops *rte_zlib_pmd_ops;
 
-#endif /* _RTE_ZLIB_PMD_PRIVATE_H_ */
+#endif /* _ZLIB_PMD_PRIVATE_H_ */
diff --git a/drivers/crypto/aesni_gcm/aesni_gcm_pmd_private.h b/drivers/crypto/aesni_gcm/aesni_gcm_pmd_private.h
index 56b29e013b25..2039adb533d0 100644
--- a/drivers/crypto/aesni_gcm/aesni_gcm_pmd_private.h
+++ b/drivers/crypto/aesni_gcm/aesni_gcm_pmd_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2016-2017 Intel Corporation
  */
 
-#ifndef _RTE_AESNI_GCM_PMD_PRIVATE_H_
-#define _RTE_AESNI_GCM_PMD_PRIVATE_H_
+#ifndef _AESNI_GCM_PMD_PRIVATE_H_
+#define _AESNI_GCM_PMD_PRIVATE_H_
 
 #include "aesni_gcm_ops.h"
 
@@ -115,4 +115,4 @@ aesni_gcm_set_session_parameters(const struct aesni_gcm_ops *ops,
 extern struct rte_cryptodev_ops *rte_aesni_gcm_pmd_ops;
 
 
-#endif /* _RTE_AESNI_GCM_PMD_PRIVATE_H_ */
+#endif /* _AESNI_GCM_PMD_PRIVATE_H_ */
diff --git a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd_private.h b/drivers/crypto/aesni_mb/aesni_mb_pmd_private.h
similarity index 98%
rename from drivers/crypto/aesni_mb/rte_aesni_mb_pmd_private.h
rename to drivers/crypto/aesni_mb/aesni_mb_pmd_private.h
index b794d4bc1a02..3456693c25e1 100644
--- a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd_private.h
+++ b/drivers/crypto/aesni_mb/aesni_mb_pmd_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2015-2016 Intel Corporation
  */
 
-#ifndef _RTE_AESNI_MB_PMD_PRIVATE_H_
-#define _RTE_AESNI_MB_PMD_PRIVATE_H_
+#ifndef _AESNI_MB_PMD_PRIVATE_H_
+#define _AESNI_MB_PMD_PRIVATE_H_
 
 #include <intel-ipsec-mb.h>
 
@@ -277,4 +277,4 @@ extern struct rte_cryptodev_ops *rte_aesni_mb_pmd_ops;
 
 
 
-#endif /* _RTE_AESNI_MB_PMD_PRIVATE_H_ */
+#endif /* _AESNI_MB_PMD_PRIVATE_H_ */
diff --git a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c b/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
index ce1144b957b1..3109392da98b 100644
--- a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
+++ b/drivers/crypto/aesni_mb/rte_aesni_mb_pmd.c
@@ -12,7 +12,7 @@
 #include <rte_malloc.h>
 #include <rte_cpuflags.h>
 
-#include "rte_aesni_mb_pmd_private.h"
+#include "aesni_mb_pmd_private.h"
 
 #define AES_CCM_DIGEST_MIN_LEN 4
 #define AES_CCM_DIGEST_MAX_LEN 16
diff --git a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd_ops.c b/drivers/crypto/aesni_mb/rte_aesni_mb_pmd_ops.c
index 8d15b99d4936..d8609ad11428 100644
--- a/drivers/crypto/aesni_mb/rte_aesni_mb_pmd_ops.c
+++ b/drivers/crypto/aesni_mb/rte_aesni_mb_pmd_ops.c
@@ -9,7 +9,7 @@
 #include <rte_malloc.h>
 #include <rte_cryptodev_pmd.h>
 
-#include "rte_aesni_mb_pmd_private.h"
+#include "aesni_mb_pmd_private.h"
 
 
 static const struct rte_cryptodev_capabilities aesni_mb_pmd_capabilities[] = {
diff --git a/drivers/crypto/armv8/rte_armv8_pmd_private.h b/drivers/crypto/armv8/armv8_pmd_private.h
similarity index 98%
rename from drivers/crypto/armv8/rte_armv8_pmd_private.h
rename to drivers/crypto/armv8/armv8_pmd_private.h
index 0afd9c7c53e6..24040dda26a3 100644
--- a/drivers/crypto/armv8/rte_armv8_pmd_private.h
+++ b/drivers/crypto/armv8/armv8_pmd_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2017 Cavium, Inc
  */
 
-#ifndef _RTE_ARMV8_PMD_PRIVATE_H_
-#define _RTE_ARMV8_PMD_PRIVATE_H_
+#ifndef _ARMV8_PMD_PRIVATE_H_
+#define _ARMV8_PMD_PRIVATE_H_
 
 #define CRYPTODEV_NAME_ARMV8_PMD	crypto_armv8
 /**< ARMv8 Crypto PMD device name */
@@ -196,4 +196,4 @@ extern int armv8_crypto_set_session_parameters(
 /** device specific operations function pointer structure */
 extern struct rte_cryptodev_ops *rte_armv8_crypto_pmd_ops;
 
-#endif /* _RTE_ARMV8_PMD_PRIVATE_H_ */
+#endif /* _ARMV8_PMD_PRIVATE_H_ */
diff --git a/drivers/crypto/armv8/rte_armv8_pmd.c b/drivers/crypto/armv8/rte_armv8_pmd.c
index 711701a974c6..7dc83e69e185 100644
--- a/drivers/crypto/armv8/rte_armv8_pmd.c
+++ b/drivers/crypto/armv8/rte_armv8_pmd.c
@@ -14,7 +14,7 @@
 
 #include "armv8_crypto_defs.h"
 
-#include "rte_armv8_pmd_private.h"
+#include "armv8_pmd_private.h"
 
 static uint8_t cryptodev_driver_id;
 
diff --git a/drivers/crypto/armv8/rte_armv8_pmd_ops.c b/drivers/crypto/armv8/rte_armv8_pmd_ops.c
index a4fee83a8c32..57952bef5bf2 100644
--- a/drivers/crypto/armv8/rte_armv8_pmd_ops.c
+++ b/drivers/crypto/armv8/rte_armv8_pmd_ops.c
@@ -10,7 +10,7 @@
 
 #include "armv8_crypto_defs.h"
 
-#include "rte_armv8_pmd_private.h"
+#include "armv8_pmd_private.h"
 
 static const struct rte_cryptodev_capabilities
 	armv8_crypto_pmd_capabilities[] = {
diff --git a/drivers/crypto/dpaa2_sec/dpaa2_sec_priv.h b/drivers/crypto/dpaa2_sec/dpaa2_sec_priv.h
index ca4fcfe9b70b..e34951de40d2 100644
--- a/drivers/crypto/dpaa2_sec/dpaa2_sec_priv.h
+++ b/drivers/crypto/dpaa2_sec/dpaa2_sec_priv.h
@@ -5,8 +5,8 @@
  *
  */
 
-#ifndef _RTE_DPAA2_SEC_PMD_PRIVATE_H_
-#define _RTE_DPAA2_SEC_PMD_PRIVATE_H_
+#ifndef _DPAA2_SEC_PMD_PRIVATE_H_
+#define _DPAA2_SEC_PMD_PRIVATE_H_
 
 #include <rte_security_driver.h>
 
@@ -734,4 +734,4 @@ calc_chksum(void *buffer, int len)
 	return  result;
 }
 
-#endif /* _RTE_DPAA2_SEC_PMD_PRIVATE_H_ */
+#endif /* _DPAA2_SEC_PMD_PRIVATE_H_ */
diff --git a/drivers/crypto/kasumi/rte_kasumi_pmd_private.h b/drivers/crypto/kasumi/kasumi_pmd_private.h
similarity index 94%
rename from drivers/crypto/kasumi/rte_kasumi_pmd_private.h
rename to drivers/crypto/kasumi/kasumi_pmd_private.h
index 76f746c031a0..7ac19c57350f 100644
--- a/drivers/crypto/kasumi/rte_kasumi_pmd_private.h
+++ b/drivers/crypto/kasumi/kasumi_pmd_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2016-2018 Intel Corporation
  */
 
-#ifndef _RTE_KASUMI_PMD_PRIVATE_H_
-#define _RTE_KASUMI_PMD_PRIVATE_H_
+#ifndef _KASUMI_PMD_PRIVATE_H_
+#define _KASUMI_PMD_PRIVATE_H_
 
 #include <sso_kasumi.h>
 
@@ -74,4 +74,4 @@ kasumi_set_session_parameters(struct kasumi_session *sess,
 /** device specific operations function pointer structure */
 struct rte_cryptodev_ops *rte_kasumi_pmd_ops;
 
-#endif /* _RTE_KASUMI_PMD_PRIVATE_H_ */
+#endif /* _KASUMI_PMD_PRIVATE_H_ */
diff --git a/drivers/crypto/kasumi/rte_kasumi_pmd.c b/drivers/crypto/kasumi/rte_kasumi_pmd.c
index 3abdb01a9628..d0583ef073f7 100644
--- a/drivers/crypto/kasumi/rte_kasumi_pmd.c
+++ b/drivers/crypto/kasumi/rte_kasumi_pmd.c
@@ -10,7 +10,7 @@
 #include <rte_malloc.h>
 #include <rte_cpuflags.h>
 
-#include "rte_kasumi_pmd_private.h"
+#include "kasumi_pmd_private.h"
 
 #define KASUMI_KEY_LENGTH 16
 #define KASUMI_IV_LENGTH 8
diff --git a/drivers/crypto/kasumi/rte_kasumi_pmd_ops.c b/drivers/crypto/kasumi/rte_kasumi_pmd_ops.c
index a4982f0916a2..5ce49534f658 100644
--- a/drivers/crypto/kasumi/rte_kasumi_pmd_ops.c
+++ b/drivers/crypto/kasumi/rte_kasumi_pmd_ops.c
@@ -8,7 +8,7 @@
 #include <rte_malloc.h>
 #include <rte_cryptodev_pmd.h>
 
-#include "rte_kasumi_pmd_private.h"
+#include "kasumi_pmd_private.h"
 
 static const struct rte_cryptodev_capabilities kasumi_pmd_capabilities[] = {
 	{	/* KASUMI (F9) */
diff --git a/drivers/crypto/mvsam/rte_mrvl_pmd_private.h b/drivers/crypto/mvsam/mrvl_pmd_private.h
similarity index 95%
rename from drivers/crypto/mvsam/rte_mrvl_pmd_private.h
rename to drivers/crypto/mvsam/mrvl_pmd_private.h
index deb80c55d6fd..09702b9e3eae 100644
--- a/drivers/crypto/mvsam/rte_mrvl_pmd_private.h
+++ b/drivers/crypto/mvsam/mrvl_pmd_private.h
@@ -4,8 +4,8 @@
  * All rights reserved.
  */
 
-#ifndef _RTE_MRVL_PMD_PRIVATE_H_
-#define _RTE_MRVL_PMD_PRIVATE_H_
+#ifndef _MRVL_PMD_PRIVATE_H_
+#define _MRVL_PMD_PRIVATE_H_
 
 #include "rte_mrvl_compat.h"
 
@@ -89,4 +89,4 @@ mrvl_crypto_set_session_parameters(struct mrvl_crypto_session *sess,
 /** device specific operations function pointer structure */
 extern struct rte_cryptodev_ops *rte_mrvl_crypto_pmd_ops;
 
-#endif /* _RTE_MRVL_PMD_PRIVATE_H_ */
+#endif /* _MRVL_PMD_PRIVATE_H_ */
diff --git a/drivers/crypto/mvsam/rte_mrvl_pmd.c b/drivers/crypto/mvsam/rte_mrvl_pmd.c
index 0aafcc1503f1..3c0fe216f096 100644
--- a/drivers/crypto/mvsam/rte_mrvl_pmd.c
+++ b/drivers/crypto/mvsam/rte_mrvl_pmd.c
@@ -14,7 +14,7 @@
 #include <rte_kvargs.h>
 #include <rte_mvep_common.h>
 
-#include "rte_mrvl_pmd_private.h"
+#include "mrvl_pmd_private.h"
 
 #define MRVL_PMD_MAX_NB_SESS_ARG		("max_nb_sessions")
 #define MRVL_PMD_DEFAULT_MAX_NB_SESSIONS	2048
diff --git a/drivers/crypto/mvsam/rte_mrvl_pmd_ops.c b/drivers/crypto/mvsam/rte_mrvl_pmd_ops.c
index 56a54500ed06..2dfaa0b11384 100644
--- a/drivers/crypto/mvsam/rte_mrvl_pmd_ops.c
+++ b/drivers/crypto/mvsam/rte_mrvl_pmd_ops.c
@@ -10,7 +10,7 @@
 #include <rte_malloc.h>
 #include <rte_cryptodev_pmd.h>
 
-#include "rte_mrvl_pmd_private.h"
+#include "mrvl_pmd_private.h"
 
 /**
  * Capabilities list to be used in reporting to DPDK.
diff --git a/drivers/crypto/openssl/rte_openssl_pmd_private.h b/drivers/crypto/openssl/openssl_pmd_private.h
similarity index 100%
rename from drivers/crypto/openssl/rte_openssl_pmd_private.h
rename to drivers/crypto/openssl/openssl_pmd_private.h
diff --git a/drivers/crypto/openssl/rte_openssl_pmd.c b/drivers/crypto/openssl/rte_openssl_pmd.c
index b05f6adb9289..6a75223fff58 100644
--- a/drivers/crypto/openssl/rte_openssl_pmd.c
+++ b/drivers/crypto/openssl/rte_openssl_pmd.c
@@ -13,7 +13,7 @@
 #include <openssl/hmac.h>
 #include <openssl/evp.h>
 
-#include "rte_openssl_pmd_private.h"
+#include "openssl_pmd_private.h"
 #include "compat.h"
 
 #define DES_BLOCK_SIZE 8
diff --git a/drivers/crypto/openssl/rte_openssl_pmd_ops.c b/drivers/crypto/openssl/rte_openssl_pmd_ops.c
index a307c91ec806..cbfb8149f93f 100644
--- a/drivers/crypto/openssl/rte_openssl_pmd_ops.c
+++ b/drivers/crypto/openssl/rte_openssl_pmd_ops.c
@@ -8,7 +8,7 @@
 #include <rte_malloc.h>
 #include <rte_cryptodev_pmd.h>
 
-#include "rte_openssl_pmd_private.h"
+#include "openssl_pmd_private.h"
 #include "compat.h"
 
 
diff --git a/drivers/crypto/snow3g/rte_snow3g_pmd.c b/drivers/crypto/snow3g/rte_snow3g_pmd.c
index 68d7176f4810..9d07e1ab2c21 100644
--- a/drivers/crypto/snow3g/rte_snow3g_pmd.c
+++ b/drivers/crypto/snow3g/rte_snow3g_pmd.c
@@ -10,7 +10,7 @@
 #include <rte_malloc.h>
 #include <rte_cpuflags.h>
 
-#include "rte_snow3g_pmd_private.h"
+#include "snow3g_pmd_private.h"
 
 #define SNOW3G_IV_LENGTH 16
 #define SNOW3G_MAX_BURST 8
diff --git a/drivers/crypto/snow3g/rte_snow3g_pmd_ops.c b/drivers/crypto/snow3g/rte_snow3g_pmd_ops.c
index d2125233f897..8778f281a9a8 100644
--- a/drivers/crypto/snow3g/rte_snow3g_pmd_ops.c
+++ b/drivers/crypto/snow3g/rte_snow3g_pmd_ops.c
@@ -8,7 +8,7 @@
 #include <rte_malloc.h>
 #include <rte_cryptodev_pmd.h>
 
-#include "rte_snow3g_pmd_private.h"
+#include "snow3g_pmd_private.h"
 
 static const struct rte_cryptodev_capabilities snow3g_pmd_capabilities[] = {
 	{	/* SNOW 3G (UIA2) */
diff --git a/drivers/crypto/snow3g/rte_snow3g_pmd_private.h b/drivers/crypto/snow3g/snow3g_pmd_private.h
similarity index 94%
rename from drivers/crypto/snow3g/rte_snow3g_pmd_private.h
rename to drivers/crypto/snow3g/snow3g_pmd_private.h
index 95a3eba22d3f..1fe05eb56783 100644
--- a/drivers/crypto/snow3g/rte_snow3g_pmd_private.h
+++ b/drivers/crypto/snow3g/snow3g_pmd_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2016-2018 Intel Corporation
  */
 
-#ifndef _RTE_SNOW3G_PMD_PRIVATE_H_
-#define _RTE_SNOW3G_PMD_PRIVATE_H_
+#ifndef _SNOW3G_PMD_PRIVATE_H_
+#define _SNOW3G_PMD_PRIVATE_H_
 
 #include <sso_snow3g.h>
 
@@ -77,4 +77,4 @@ extern struct rte_cryptodev_ops *rte_snow3g_pmd_ops;
 
 
 
-#endif /* _RTE_SNOW3G_PMD_PRIVATE_H_ */
+#endif /* _SNOW3G_PMD_PRIVATE_H_ */
diff --git a/drivers/crypto/zuc/rte_zuc_pmd.c b/drivers/crypto/zuc/rte_zuc_pmd.c
index 637994dfd38f..8e214cd50ec3 100644
--- a/drivers/crypto/zuc/rte_zuc_pmd.c
+++ b/drivers/crypto/zuc/rte_zuc_pmd.c
@@ -10,7 +10,7 @@
 #include <rte_malloc.h>
 #include <rte_cpuflags.h>
 
-#include "rte_zuc_pmd_private.h"
+#include "zuc_pmd_private.h"
 #define ZUC_MAX_BURST 4
 #define BYTE_LEN 8
 
diff --git a/drivers/crypto/zuc/rte_zuc_pmd_ops.c b/drivers/crypto/zuc/rte_zuc_pmd_ops.c
index 1b88947eb149..62f8c6cedd01 100644
--- a/drivers/crypto/zuc/rte_zuc_pmd_ops.c
+++ b/drivers/crypto/zuc/rte_zuc_pmd_ops.c
@@ -8,7 +8,7 @@
 #include <rte_malloc.h>
 #include <rte_cryptodev_pmd.h>
 
-#include "rte_zuc_pmd_private.h"
+#include "zuc_pmd_private.h"
 
 static const struct rte_cryptodev_capabilities zuc_pmd_capabilities[] = {
 	{	/* ZUC (EIA3) */
diff --git a/drivers/crypto/zuc/rte_zuc_pmd_private.h b/drivers/crypto/zuc/zuc_pmd_private.h
similarity index 95%
rename from drivers/crypto/zuc/rte_zuc_pmd_private.h
rename to drivers/crypto/zuc/zuc_pmd_private.h
index aa73c0016974..428efd4bb5db 100644
--- a/drivers/crypto/zuc/rte_zuc_pmd_private.h
+++ b/drivers/crypto/zuc/zuc_pmd_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2016-2018 Intel Corporation
  */
 
-#ifndef _RTE_ZUC_PMD_PRIVATE_H_
-#define _RTE_ZUC_PMD_PRIVATE_H_
+#ifndef _ZUC_PMD_PRIVATE_H_
+#define _ZUC_PMD_PRIVATE_H_
 
 #include <sso_zuc.h>
 
@@ -76,4 +76,4 @@ extern struct rte_cryptodev_ops *rte_zuc_pmd_ops;
 
 
 
-#endif /* _RTE_ZUC_PMD_PRIVATE_H_ */
+#endif /* _ZUC_PMD_PRIVATE_H_ */
diff --git a/drivers/net/bonding/rte_eth_bond_8023ad_private.h b/drivers/net/bonding/eth_bond_8023ad_private.h
similarity index 98%
rename from drivers/net/bonding/rte_eth_bond_8023ad_private.h
rename to drivers/net/bonding/eth_bond_8023ad_private.h
index 1470bf7b010d..6e44ffdb1cf7 100644
--- a/drivers/net/bonding/rte_eth_bond_8023ad_private.h
+++ b/drivers/net/bonding/eth_bond_8023ad_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2010-2014 Intel Corporation
  */
 
-#ifndef RTE_ETH_BOND_8023AD_PRIVATE_H_
-#define RTE_ETH_BOND_8023AD_PRIVATE_H_
+#ifndef _ETH_BOND_8023AD_PRIVATE_H_
+#define _ETH_BOND_8023AD_PRIVATE_H_
 
 #include <stdint.h>
 
@@ -305,4 +305,4 @@ bond_ethdev_8023ad_flow_set(struct rte_eth_dev *bond_dev, uint16_t slave_port);
 int
 bond_8023ad_slow_pkt_hw_filter_supported(uint16_t port_id);
 
-#endif /* RTE_ETH_BOND_8023AD_H_ */
+#endif /* _ETH_BOND_8023AD_H_ */
diff --git a/drivers/net/bonding/rte_eth_bond_private.h b/drivers/net/bonding/eth_bond_private.h
similarity index 98%
rename from drivers/net/bonding/rte_eth_bond_private.h
rename to drivers/net/bonding/eth_bond_private.h
index a5a2d7f760db..c9b2d0fe4609 100644
--- a/drivers/net/bonding/rte_eth_bond_private.h
+++ b/drivers/net/bonding/eth_bond_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2010-2017 Intel Corporation
  */
 
-#ifndef _RTE_ETH_BOND_PRIVATE_H_
-#define _RTE_ETH_BOND_PRIVATE_H_
+#ifndef _ETH_BOND_PRIVATE_H_
+#define _ETH_BOND_PRIVATE_H_
 
 #include <stdint.h>
 #include <sys/queue.h>
@@ -15,7 +15,7 @@
 #include <rte_flow_driver.h>
 
 #include "rte_eth_bond.h"
-#include "rte_eth_bond_8023ad_private.h"
+#include "eth_bond_8023ad_private.h"
 #include "rte_eth_bond_alb.h"
 
 #define PMD_BOND_SLAVE_PORT_KVARG			("slave")
diff --git a/drivers/net/bonding/rte_eth_bond_8023ad.c b/drivers/net/bonding/rte_eth_bond_8023ad.c
index 7d8da2b318f5..badcd109ae68 100644
--- a/drivers/net/bonding/rte_eth_bond_8023ad.c
+++ b/drivers/net/bonding/rte_eth_bond_8023ad.c
@@ -12,7 +12,7 @@
 #include <rte_cycles.h>
 #include <rte_compat.h>
 
-#include "rte_eth_bond_private.h"
+#include "eth_bond_private.h"
 
 static void bond_mode_8023ad_ext_periodic_cb(void *arg);
 #ifdef RTE_LIBRTE_BOND_DEBUG_8023AD
diff --git a/drivers/net/bonding/rte_eth_bond_alb.c b/drivers/net/bonding/rte_eth_bond_alb.c
index 712c3c4b7649..1d36a4a4a2cb 100644
--- a/drivers/net/bonding/rte_eth_bond_alb.c
+++ b/drivers/net/bonding/rte_eth_bond_alb.c
@@ -2,7 +2,7 @@
  * Copyright(c) 2010-2015 Intel Corporation
  */
 
-#include "rte_eth_bond_private.h"
+#include "eth_bond_private.h"
 #include "rte_eth_bond_alb.h"
 
 static inline uint8_t
diff --git a/drivers/net/bonding/rte_eth_bond_api.c b/drivers/net/bonding/rte_eth_bond_api.c
index 2cef8872045a..f38eb3b47fba 100644
--- a/drivers/net/bonding/rte_eth_bond_api.c
+++ b/drivers/net/bonding/rte_eth_bond_api.c
@@ -12,8 +12,8 @@
 #include <rte_kvargs.h>
 
 #include "rte_eth_bond.h"
-#include "rte_eth_bond_private.h"
-#include "rte_eth_bond_8023ad_private.h"
+#include "eth_bond_private.h"
+#include "eth_bond_8023ad_private.h"
 
 int
 check_for_bonded_ethdev(const struct rte_eth_dev *eth_dev)
diff --git a/drivers/net/bonding/rte_eth_bond_args.c b/drivers/net/bonding/rte_eth_bond_args.c
index f298ea0e176e..3b41d2bcd412 100644
--- a/drivers/net/bonding/rte_eth_bond_args.c
+++ b/drivers/net/bonding/rte_eth_bond_args.c
@@ -8,7 +8,7 @@
 #include <rte_kvargs.h>
 
 #include "rte_eth_bond.h"
-#include "rte_eth_bond_private.h"
+#include "eth_bond_private.h"
 
 const char *pmd_bond_init_valid_arguments[] = {
 	PMD_BOND_SLAVE_PORT_KVARG,
diff --git a/drivers/net/bonding/rte_eth_bond_flow.c b/drivers/net/bonding/rte_eth_bond_flow.c
index f94d46ca4956..417f76bf60fd 100644
--- a/drivers/net/bonding/rte_eth_bond_flow.c
+++ b/drivers/net/bonding/rte_eth_bond_flow.c
@@ -11,7 +11,7 @@
 #include <rte_tailq.h>
 #include <rte_flow.h>
 
-#include "rte_eth_bond_private.h"
+#include "eth_bond_private.h"
 
 static struct rte_flow *
 bond_flow_alloc(int numa_node, const struct rte_flow_attr *attr,
diff --git a/drivers/net/bonding/rte_eth_bond_pmd.c b/drivers/net/bonding/rte_eth_bond_pmd.c
index a2d13d95c429..11cd7fc51350 100644
--- a/drivers/net/bonding/rte_eth_bond_pmd.c
+++ b/drivers/net/bonding/rte_eth_bond_pmd.c
@@ -21,8 +21,8 @@
 #include <rte_string_fns.h>
 
 #include "rte_eth_bond.h"
-#include "rte_eth_bond_private.h"
-#include "rte_eth_bond_8023ad_private.h"
+#include "eth_bond_private.h"
+#include "eth_bond_8023ad_private.h"
 
 #define REORDER_PERIOD_MS 10
 #define DEFAULT_POLLING_INTERVAL_10_MS (10)
diff --git a/drivers/net/failsafe/failsafe_private.h b/drivers/net/failsafe/failsafe_private.h
index e376b35b3367..8e9706aef0a8 100644
--- a/drivers/net/failsafe/failsafe_private.h
+++ b/drivers/net/failsafe/failsafe_private.h
@@ -3,8 +3,8 @@
  * Copyright 2017 Mellanox Technologies, Ltd
  */
 
-#ifndef _RTE_ETH_FAILSAFE_PRIVATE_H_
-#define _RTE_ETH_FAILSAFE_PRIVATE_H_
+#ifndef _ETH_FAILSAFE_PRIVATE_H_
+#define _ETH_FAILSAFE_PRIVATE_H_
 
 #include <stdint.h>
 #include <sys/queue.h>
@@ -493,4 +493,4 @@ fs_err(struct sub_device *sdev, int err)
 		return rte_errno = 0;
 	return err;
 }
-#endif /* _RTE_ETH_FAILSAFE_PRIVATE_H_ */
+#endif /* _ETH_FAILSAFE_PRIVATE_H_ */
diff --git a/lib/librte_distributor/rte_distributor_private.h b/lib/librte_distributor/distributor_private.h
similarity index 98%
rename from lib/librte_distributor/rte_distributor_private.h
rename to lib/librte_distributor/distributor_private.h
index 33cd89410c9c..c89371123e4b 100644
--- a/lib/librte_distributor/rte_distributor_private.h
+++ b/lib/librte_distributor/distributor_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2017 Intel Corporation
  */
 
-#ifndef _RTE_DIST_PRIV_H_
-#define _RTE_DIST_PRIV_H_
+#ifndef _DIST_PRIV_H_
+#define _DIST_PRIV_H_
 
 /**
  * @file
@@ -171,4 +171,4 @@ find_match_vec(struct rte_distributor *d,
 }
 #endif
 
-#endif
+#endif /* _DIST_PRIV_H_ */
diff --git a/lib/librte_distributor/rte_distributor.c b/lib/librte_distributor/rte_distributor.c
index 21eb1fb0a1c1..37b58efb17b2 100644
--- a/lib/librte_distributor/rte_distributor.c
+++ b/lib/librte_distributor/rte_distributor.c
@@ -16,10 +16,10 @@
 #include <rte_pause.h>
 #include <rte_tailq.h>
 
-#include "rte_distributor_private.h"
 #include "rte_distributor.h"
 #include "rte_distributor_v20.h"
 #include "rte_distributor_v1705.h"
+#include "distributor_private.h"
 
 TAILQ_HEAD(rte_dist_burst_list, rte_distributor);
 
diff --git a/lib/librte_distributor/rte_distributor_match_generic.c b/lib/librte_distributor/rte_distributor_match_generic.c
index 6b681032f139..037ba0df33ef 100644
--- a/lib/librte_distributor/rte_distributor_match_generic.c
+++ b/lib/librte_distributor/rte_distributor_match_generic.c
@@ -3,8 +3,8 @@
  */
 
 #include <rte_mbuf.h>
-#include "rte_distributor_private.h"
 #include "rte_distributor.h"
+#include "distributor_private.h"
 
 void
 find_match_vec(struct rte_distributor *d,
diff --git a/lib/librte_distributor/rte_distributor_match_sse.c b/lib/librte_distributor/rte_distributor_match_sse.c
index f7d165238875..e3b3b79264bb 100644
--- a/lib/librte_distributor/rte_distributor_match_sse.c
+++ b/lib/librte_distributor/rte_distributor_match_sse.c
@@ -3,8 +3,8 @@
  */
 
 #include <rte_mbuf.h>
-#include "rte_distributor_private.h"
 #include "rte_distributor.h"
+#include "distributor_private.h"
 #include "smmintrin.h"
 #include "nmmintrin.h"
 
diff --git a/lib/librte_distributor/rte_distributor_v20.c b/lib/librte_distributor/rte_distributor_v20.c
index cdc0969a89e5..b368a7488ddb 100644
--- a/lib/librte_distributor/rte_distributor_v20.c
+++ b/lib/librte_distributor/rte_distributor_v20.c
@@ -16,7 +16,7 @@
 #include <rte_tailq.h>
 
 #include "rte_distributor_v20.h"
-#include "rte_distributor_private.h"
+#include "distributor_private.h"
 
 TAILQ_HEAD(rte_distributor_list, rte_distributor_v20);
 
diff --git a/lib/librte_eal/common/include/rte_service_component.h b/lib/librte_eal/common/include/rte_service_component.h
index c12adbc2565b..16eab79eead3 100644
--- a/lib/librte_eal/common/include/rte_service_component.h
+++ b/lib/librte_eal/common/include/rte_service_component.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2017 Intel Corporation
  */
 
-#ifndef _RTE_SERVICE_PRIVATE_H_
-#define _RTE_SERVICE_PRIVATE_H_
+#ifndef _SERVICE_PRIVATE_H_
+#define _SERVICE_PRIVATE_H_
 
 /* This file specifies the internal service specification.
  * Include this file if you are writing a component that requires CPU cycles to
@@ -126,4 +126,4 @@ int32_t rte_service_init(void);
  */
 void rte_service_finalize(void);
 
-#endif /* _RTE_SERVICE_PRIVATE_H_ */
+#endif /* _SERVICE_PRIVATE_H_ */
diff --git a/lib/librte_ethdev/ethdev_private.h b/lib/librte_ethdev/ethdev_private.h
index 7b787bf97f03..905a45c33744 100644
--- a/lib/librte_ethdev/ethdev_private.h
+++ b/lib/librte_ethdev/ethdev_private.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2018 Gaëtan Rivet
  */
 
-#ifndef _RTE_ETH_PRIVATE_H_
-#define _RTE_ETH_PRIVATE_H_
+#ifndef _ETH_PRIVATE_H_
+#define _ETH_PRIVATE_H_
 
 #include "rte_ethdev.h"
 
@@ -35,4 +35,4 @@ int rte_eth_devargs_parse_representor_ports(char *str, void *data);
 }
 #endif
 
-#endif /* _RTE_ETH_PRIVATE_H_ */
+#endif /* _ETH_PRIVATE_H_ */
diff --git a/lib/librte_stack/rte_stack.c b/lib/librte_stack/rte_stack.c
index 2cc7e8e1695e..d19824f00439 100644
--- a/lib/librte_stack/rte_stack.c
+++ b/lib/librte_stack/rte_stack.c
@@ -15,7 +15,7 @@
 #include <rte_tailq.h>
 
 #include "rte_stack.h"
-#include "rte_stack_pvt.h"
+#include "stack_pvt.h"
 
 int stack_logtype;
 
diff --git a/lib/librte_stack/rte_stack_pvt.h b/lib/librte_stack/stack_pvt.h
similarity index 86%
rename from lib/librte_stack/rte_stack_pvt.h
rename to lib/librte_stack/stack_pvt.h
index 4a6a7bdb3bac..ecf40819c5df 100644
--- a/lib/librte_stack/rte_stack_pvt.h
+++ b/lib/librte_stack/stack_pvt.h
@@ -2,8 +2,8 @@
  * Copyright(c) 2019 Intel Corporation
  */
 
-#ifndef _RTE_STACK_PVT_H_
-#define _RTE_STACK_PVT_H_
+#ifndef _STACK_PVT_H_
+#define _STACK_PVT_H_
 
 #ifdef __cplusplus
 extern "C" {
@@ -31,4 +31,4 @@ extern int stack_logtype;
 }
 #endif
 
-#endif /* _RTE_STACK_PVT_H_ */
+#endif /* _STACK_PVT_H_ */